From 2383f45cf9edfc28abdbe5667b8e28837bb04f77 Mon Sep 17 00:00:00 2001
From: Karim Malhas <karim@malhas.de>
Date: Wed, 22 Feb 2012 13:42:31 +0100
Subject: [PATCH] added silent install options

---
 .../win32inst/postgis.nsi                          |   31 +++++++++++++++++--
 1 files changed, 27 insertions(+), 4 deletions(-)

diff --git a/postgis-pg84-1.5.3-installersrc/win32inst/postgis.nsi b/postgis-pg84-1.5.3-installersrc/win32inst/postgis.nsi
index da6a28b..04bf497 100644
--- a/postgis-pg84-1.5.3-installersrc/win32inst/postgis.nsi
+++ b/postgis-pg84-1.5.3-installersrc/win32inst/postgis.nsi
@@ -17,6 +17,9 @@ SetCompressor lzma
 ; Sections
 !include "Sections.nsh"
 
+!include FileFunc.nsh
+!insertmacro GetParameters
+!insertmacro GetOptions
 ; Modern User Interface
 !include "MUI.nsh"
 
@@ -160,7 +163,7 @@ Section "PostGIS" SecPostGIS
 
 		postgis_template_exists:
 			; The template_postgis database exists from a previous installation
-			MessageBox MB_YESNO "WARNING: The installer has detected that the PostGIS template database '${POSTGIS_TEMPLATE}' already exists in your PostgreSQL installation. In order to install this version of PostGIS, it is necessary to create a new '${POSTGIS_TEMPLATE}' database, so any manual changes you have made to this database will be lost.$\r$\n$\r$\nDo you still wish to proceed with the installation?" IDYES postgis_remove_template IDNO postgis_abort_install
+			MessageBox MB_YESNO "WARNING: The installer has detected that the PostGIS template database '${POSTGIS_TEMPLATE}' already exists in your PostgreSQL installation. In order to install this version of PostGIS, it is necessary to create a new '${POSTGIS_TEMPLATE}' database, so any manual changes you have made to this database will be lost.$\r$\n$\r$\nDo you still wish to proceed with the installation?" /SD IDYES IDYES postgis_remove_template IDNO postgis_abort_install
 
 			postgis_remove_template:
 				; We need to remove the existing template_postgis
@@ -327,6 +330,26 @@ oninit_usedefaultconnectinfo:
 	; Extract the database name page info
 	File /oname=$PLUGINSDIR\postgis_dbname.ini ".\postgis_dbname.ini"
 
+
+; Command line Parameter overrides
+    ${GetParameters} $R0
+    ClearErrors
+    Push $0
+    ${GetOptions} $R0 /USERNAME= $0
+    StrCmp $0 "" +2 0
+	WriteINIStr "$PLUGINSDIR\postgis_dbconn.ini" "Field 3" "State" "$0"
+    ${GetOptions} $R0 /PASSWORD= $0
+    StrCmp $0 "" +2 0
+	WriteINIStr "$PLUGINSDIR\postgis_dbconn.ini" "Field 5" "State" "$0"
+    ${GetOptions} $R0 /PORT= $0
+    StrCmp $0 "" +2 0
+	WriteINIStr "$PLUGINSDIR\postgis_dbconn.ini" "Field 7" "State" "$0"
+    ${GetOptions} $R0 /DATABASE= $0
+    StrCmp $0 "" +2 0
+	WriteINIStr "$PLUGINSDIR\postgis_dbname.ini" "Field 3" "State" "$0"
+
+    Pop $0
+
 FunctionEnd
 
 ; Init/Exit functions for the database connection page
@@ -579,7 +602,7 @@ FunctionEnd
 Function AbortDisplayLogOption
 
 	; Display a message box with the error
-	MessageBox MB_YESNO|MB_ICONSTOP "$R8$\r$\n$\r$\nWould you like to view the error log '$R9'?" IDYES adlo_show_error_log
+	MessageBox MB_YESNO|MB_ICONSTOP "$R8$\r$\n$\r$\nWould you like to view the error log '$R9'?" /SD IDNO IDYES adlo_show_error_log
 
 	; If the user selects NO, simply abort the installation
 	DetailPrint "$R8"
@@ -598,11 +621,11 @@ FunctionEnd
 ; CreateTemplatePostGIS - create the template_postgis db by loading in the postgis.sql and spatial_ref_sys.sql files.
 Function EnablePostGISPgAdminPlugin
 ; Display a message box offering to overwrite
-	MessageBox MB_YESNO "Would you like to enable the shp2pgsql graphical loader plugin in PostgreSQL PgAdmin III? $\r$\n If you choose Yes, this will overwrite the plugins.ini in your PostgreSQL PgAdminIII subfolder and back it up to plugins.ini.bak. $\r$\n If you choose No, you can later replace your plugins.ini $\r$\nwith the plugins.postgis.ini file in your PgAdminIII PostgreSQL install folder?" IDYES overwrite_pluginsini
+	MessageBox MB_YESNO "Would you like to enable the shp2pgsql graphical loader plugin in PostgreSQL PgAdmin III? $\r$\n If you choose Yes, this will overwrite the plugins.ini in your PostgreSQL PgAdminIII subfolder and back it up to plugins.ini.bak. $\r$\n If you choose No, you can later replace your plugins.ini $\r$\nwith the plugins.postgis.ini file in your PgAdminIII PostgreSQL install folder?" /SD IDYES IDYES overwrite_pluginsini
 	Return
 	overwrite_pluginsini:
 	  CopyFiles /SILENT /FILESONLY "$INSTDIR\PgAdmin III\plugins.ini" "$INSTDIR\PgAdmin III\plugins.ini.bak"
 	  CopyFiles /SILENT /FILESONLY "$INSTDIR\PgAdmin III\plugins.postgis.ini" "$INSTDIR\PgAdmin III\plugins.ini"
   
 	  Return
-FunctionEnd
\ No newline at end of file
+FunctionEnd
-- 
1.7.4.1

